diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index fbafb6b93..6adbd7322 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -352,7 +352,7 @@ public class ChunkDecoratorOverworld
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
             int j24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureTallGrass(blockId)).place(world, rand, l19, k22, j24);
+            (new WorldFeatureFlowers(blockId, 128, true)).place(world, rand, l19, k22, j24);
         }
 
         byte byteBluebells = 0;
@@ -373,7 +373,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_LIGHT_BLUE.id)).place(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_LIGHT_BLUE.id, 64, true)).place(world, rand, k14, l16, k19);
         }
 
         byte byteMarigold = 0;
@@ -396,7 +396,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_ORANGE.id)).place(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_ORANGE.id, 64, true)).place(world, rand, k14, l16, k19);
         }
 
         byte byte0 = 0;
@@ -424,7 +424,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id)).place(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id, 64, true)).place(world, rand, k14, l16, k19);
         }
 
         byte byte1 = 0;
@@ -498,19 +498,19 @@ public class ChunkDecoratorOverworld
             int j15 = x + rand.nextInt(16) + 8;
             int j17 = minY + rand.nextInt(rangeY);
             int j20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id)).place(world, rand, j15, j17, j20);
+            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id, 64, true)).place(world, rand, j15, j17, j20);
         }
         if (rand.nextInt(4) == 0) {
             int k15 = x + rand.nextInt(16) + 8;
             int k17 = minY + rand.nextInt(rangeY);
             int k20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id)).place(world, rand, k15, k17, k20);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id, 64, false)).place(world, rand, k15, k17, k20);
         }
         if (rand.nextInt(8) == 0) {
             int l15 = x + rand.nextInt(16) + 8;
             int l17 = minY + rand.nextInt(rangeY);
             int l20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id)).place(world, rand, l15, l17, l20);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id, 64, false)).place(world, rand, l15, l17, l20);
         }
         if(rand.nextInt(5) == 0) {
             int i18 = x + rand.nextInt(16) + 8;
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index 9c0f4cc33..7cca23900 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -154,7 +154,7 @@ public class ChunkDecoratorOverworldRetro
             int k13 = k + rand.nextInt(16) + 8;
             int i16 = minY + rand.nextInt(rangeY);
             int j18 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id)).place(world, rand, k13, i16, j18);
+            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id, 64, false)).place(world, rand, k13, i16, j18);
         }
 
         if (rand.nextInt(2) == 0)
@@ -162,21 +162,21 @@ public class ChunkDecoratorOverworldRetro
             int i9 = k + rand.nextInt(16) + 8;
             int l13 = minY + rand.nextInt(rangeY);
             int j16 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id)).place(world, rand, i9, l13, j16);
+            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id, 64, false)).place(world, rand, i9, l13, j16);
         }
         if (rand.nextInt(4) == 0)
         {
             int j9 = k + rand.nextInt(16) + 8;
             int i14 = minY + rand.nextInt(rangeY);
             int k16 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id)).place(world, rand, j9, i14, k16);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id, 64, false)).place(world, rand, j9, i14, k16);
         }
         if (rand.nextInt(8) == 0)
         {
             int k9 = k + rand.nextInt(16) + 8;
             int j14 = minY + rand.nextInt(rangeY);
             int l16 = l + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id)).place(world, rand, k9, j14, l16);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id, 64, false)).place(world, rand, k9, j14, l16);
         }
         for (int l9 = 0; l9 < 10; l9++)
         {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
index e2081c41b..570c494d3 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
@@ -2,9 +2,11 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.StackedFlowerBlock;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
+import java.util.Stack;
 
 // Referenced classes of package net.minecraft.src:
 //            WorldGenerator, World, Block, FlowerBlock
@@ -12,26 +14,61 @@ import java.util.Random;
 public class WorldFeatureFlowers extends WorldFeature
 {
     private final int plantBlockId;
-    @MethodParametersAnnotation(names = {"plantBlockId"})
-    public WorldFeatureFlowers(int plantBlockId)
+    private final int count;
+    private final boolean varyStackSize;
+
+    @MethodParametersAnnotation(names = {"plantBlockId", "count", "varyStackSize"})
+    public WorldFeatureFlowers(int plantBlockId, int count, boolean varyStackSize)
     {
         this.plantBlockId = plantBlockId;
+        this.count = count;
+        this.varyStackSize = varyStackSize;
     }
 
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l = 0; l < 64; l++)
+        for(int l = 0; l < count; l++)
         {
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
             if(world.isAirBlock(i1, j1, k1) && Block.blocksList[plantBlockId].canBlockStay(world, i1, j1, k1))
             {
-                world.setBlock(i1, j1, k1, plantBlockId);
+                final int metadata;
+                if (Block.getBlock(plantBlockId) instanceof StackedFlowerBlock) {
+                    final int stackSize;
+                    if (varyStackSize) {
+                        stackSize = getStackSize(random);
+                    } else {
+                        stackSize = 0;
+                    }
+
+                    metadata = StackedFlowerBlock.setStackCount(0, stackSize);
+                } else {
+                    metadata = 0;
+                }
+                world.setBlockAndMetadata(i1, j1, k1, plantBlockId, metadata);
             }
         }
 
         return true;
     }
+
+    public static int getStackSize(Random random) {
+        // 0 = 0-7 (8 chances)
+        // 1 = 8-11 (4 chances)
+        // 2 = 12-13 (2 chances)
+        // 3 = 14 (1 chance)
+        final int odds = random.nextInt(15);
+        if (odds < 8) {
+            return 0;
+        } else if (odds < 12) {
+            return 1;
+        } else if (odds < 14) {
+            return 2;
+        } else {
+            return 3;
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index e2164ccc7..5d56b987c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -224,13 +224,7 @@ public class WorldFeatureLabyrinth extends WorldFeature
         return BlockTags.CAVES_CUT_THROUGH.appliesTo(world.getBlock(x, y, z)) ||
                 world.getBlockMaterial(x, y, z) == Material.grass ||
                 world.getBlockMaterial(x, y, z) == Material.dirt ||
-                world.getBlockMaterial(x, y, z) == Material.stone ||
-                world.getBlockMaterial(x, y, z) == Material.slate ||
-                world.getBlockMaterial(x, y, z) == Material.marble ||
-                world.getBlockMaterial(x, y, z) == Material.limestone ||
-                world.getBlockMaterial(x, y, z) == Material.basalt ||
-                world.getBlockMaterial(x, y, z) == Material.granite ||
-                world.getBlockMaterial(x, y, z) == Material.permafrost ||
+                world.getBlockMaterial(x, y, z).isStone() ||
                 world.getBlockMaterial(x, y, z) == Material.sand ||
                 world.getBlockMaterial(x, y, z) == Material.moss;
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
index 3cff97531..55d70cdef 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.StackedFlowerBlock;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -24,14 +25,13 @@ public class WorldFeatureMeadow extends WorldFeature
             int k1 = (y + random.nextInt(4)) - random.nextInt(4);
             int l1 = (z + random.nextInt(8)) - random.nextInt(8);
 
-            int meta = 0;
 
             int index = random.nextInt(blockIds.length);
             int flowerId = blockIds[index];
 
-
             if(world.isAirBlock(j1, k1, l1) && Block.blocksList[flowerId].canBlockStay(world, j1, k1, l1))
             {
+                final int meta = StackedFlowerBlock.setStackCount(0, WorldFeatureFlowers.getStackSize(random));
                 world.setBlockAndMetadata(j1, k1, l1, flowerId, meta);
             }
         }
diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index fe0078274..caf11602c 100644
--- a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1156,9 +1156,9 @@ class WorkbenchGenerator {
                 "XXX",
                 "#I#",
                 "#R#")
-            .addInput('X', Items.INGOT_STEEL)
-            .addInput('#', Blocks.BRICK_STONE_POLISHED)
-            .addInput('I', Blocks.PISTON_BASE)
+            .addInput('X', Items.INGOT_STEEL_CRUDE)
+            .addInput('#', "minecraft:stones")
+            .addInput('I', Items.INGOT_STEEL)
             .addInput('R', Items.DUST_REDSTONE)
             .create("steel_piston", Blocks.PISTON_BASE_STEEL.getDefaultStack());
 
